/************************************************
 *                                              *
 *           Simple Arcade Game                 *
 *        (designed be under 10k)               *
 *          Use at YOUR own risk.               *
 *                                              *
 ************************************************/

#include <allegro.h>
#include "shoot.h"

#define GAME_SPEED 70    /* tick per second */

void do_game_init();
void do_game_logic();
void do_game_display();

DATAFILE *game_data;
BITMAP *buffer;
int frames;
int game_over;
volatile int speed_var;

void speed_func()
{
  speed_var++;
}
END_OF_FUNCTION(speed_func)

int main()
{
  LOCK_VARIABLE(speed_var);
  LOCK_FUNCTION(speed_func);

  allegro_init();
  install_timer();
  install_keyboard();

  install_int_ex(speed_func,BPS_TO_TIMER(GAME_SPEED));

  set_color_depth(8);
  #ifdef ALLEGRO_DOS
  if(set_gfx_mode(GFX_MODEX,320,240,0,0))
  #else
  if(set_gfx_mode(GFX_AUTODETECT,320,240,0,0))
  #endif
    if(set_gfx_mode(GFX_SAFE,320,200,0,0)) {
    allegro_message("Error setting gfx mode.");
    return -1;
  }

  game_data = load_datafile("shoot.dat");

  if(!game_data) {
    set_gfx_mode(GFX_TEXT,80,25,0,0);
    allegro_message("Error loading game data.");
    return -1;
  }

  buffer = create_bitmap(SCREEN_W,SCREEN_H);   /* Set up memory buffer */
  
  frames = 0;
  speed_var = 0;
  game_over = FALSE;

  do_game_init();
  
  while(!game_over) {                   /* Main game loop */
    while(speed_var>0&&frames<10) {     /* Do game logic here */
      speed_var--;
      frames++;
      do_game_logic();
      
    }
    if(frames>0&&!game_over) {                      /* Do Drawing here */
      frames=0;
      clear(buffer);
      do_game_display();
      blit(buffer,screen,0,0,0,0,SCREEN_W,SCREEN_H);
    }
  }


  return 0;
}
END_OF_MAIN()


