/*********************
 *  Game code...     *
 *********************/

#include <allegro.h>
#include <stdlib.h>
#include <time.h>
#include "shoot.h"
#include "arcade.h"


struct location {
  int x,y;
};

/* Game data */
#define max_enemys 50
static location ship,enemy[max_enemys];
static int enemy_live[max_enemys],enemy_speed[max_enemys],next_free_enemy;
static int enemy_time,enemy_speed_max,enemy_chance;
#define max_stars 50
static location stars[max_stars];
static int z_stars[max_stars];
#define max_mb 50
static location mb[max_mb];
static int mb_live[max_mb],next_mb,mb_pause,mb_speed;

static location effect_drop;
static int effect_drop_live;
static int effect_drop_speed;
static int effect_drop_pause;
static int effect_drop_type;
static int effect, effect_time, effect_on;
static int blink;
static int score;
static int level;
static int lives;
static int go_menu;
static int level_display;

void do_game_init() {
  int i;
  srand(time(NULL));
  ship.x=SCREEN_W/2;
  ship.y=SCREEN_H-((BITMAP *)game_data[main_ship].dat)->h;
  set_palette((RGB *)game_data[game_pal].dat);
  rgb_map=new RGB_MAP;
  create_rgb_table(rgb_map,(RGB *)game_data[game_pal].dat,NULL);
  for(i=0;i<max_enemys;i++)
    enemy_live[i]=FALSE;
  for(i=0;i<max_mb;i++)
    mb_live[i]=FALSE;
    
  for(i=0;i<max_stars;i++) {
    stars[i].x=rand()%SCREEN_W;
    stars[i].y=rand()%SCREEN_H;
    z_stars[i]=rand()%32;
  }
  font=(FONT *)game_data[little].dat;
  text_mode(-1);
  
  next_free_enemy=0;
  next_mb=0;
  mb_pause=0;
  mb_speed=25;
  enemy_time=0;
  score=0;
  level=0;
  lives=3;
  effect_on=FALSE;
  effect_drop_live=FALSE;
  effect_drop_speed=100;
  effect_drop_pause=0;
  enemy_chance=30;
  enemy_speed_max=1;
  go_menu=TRUE;
  level_display=1;
}

void do_game_logic() {
  int i,j;

  if(go_menu) {
    if(key[KEY_ESC]) game_over=TRUE;
    if(key[KEY_SPACE]||key[KEY_ENTER]) go_menu=FALSE;
    for(i=0;i<max_stars;i++) {
      stars[i].x+=(z_stars[i]>>2)+1;
      if(stars[i].x>SCREEN_W) {
        stars[i].x=0;
        stars[i].y=rand()%SCREEN_H;
        z_stars[i]=rand()%32;
      }
    }
    return;
  }
  if(level>level_display*50) {
    enemy_speed_max++;
    if(enemy_chance>1) enemy_chance-=3;
    if(enemy_chance<1) enemy_chance=1;
    level-=level_display*50;
    level_display++;
  }
  if(!(effect_on&&effect==3)) enemy_time++;
  if(!(effect_on&&effect==3)&&!enemy_live[next_free_enemy]&&!(rand()%enemy_chance)) {
    enemy_live[next_free_enemy]=TRUE;
    enemy[next_free_enemy].x=rand()%(SCREEN_W-(((BITMAP *)game_data[enemy_ship1].dat)->w));
    enemy[next_free_enemy].y=-((BITMAP *)game_data[enemy_ship1].dat)->h;
    enemy_speed[next_free_enemy]=rand()%enemy_speed_max+1;
  }
  if(!effect_on&&!effect_drop_live&&effect_drop_pause++>effect_drop_speed) {
    effect_drop_pause=0;
    if(!(rand()%5)) {
      effect_drop.x=rand()%SCREEN_W-8;
      effect_drop.y=0;
      effect_drop_live=TRUE;
      effect_drop_type=rand()%4+1;
    }
  }
  if(effect_drop_live) {
    if(!(effect_on&&effect==3))
      effect_drop.y+=2;
    if(effect_drop.y>SCREEN_H) effect_drop_live=FALSE;
    if(ship.x+(((BITMAP *)game_data[main_ship].dat)->w/2)>=effect_drop.x-2
       &&ship.x+(((BITMAP *)game_data[main_ship].dat)->w/2)<=effect_drop.x+6
       &&ship.y+(((BITMAP *)game_data[main_ship].dat)->h/2)>=effect_drop.y-2
       &&ship.y+(((BITMAP *)game_data[main_ship].dat)->h/2)<=effect_drop.y+8
      ) {
      effect_drop_live=FALSE;
      effect_on=TRUE;
      effect_time=250;
      effect=effect_drop_type;
    }
  }
  if(key[KEY_SPACE]) {
    if(!mb_live[next_free_enemy]&&mb_pause==0) {
      mb_pause=mb_speed;
      mb_live[next_free_enemy]=TRUE;
      mb[next_free_enemy].x=ship.x+(((BITMAP *)game_data[main_ship].dat)->w/2);
      mb[next_free_enemy].y=ship.y;
    }
    next_mb++;
    if(next_mb>=max_mb) next_mb=0;
  }
  if(mb_pause>0) mb_pause--;
  next_free_enemy++;
  if(next_free_enemy>=max_enemys) next_free_enemy=0;
  for(i=0;i<max_enemys;i++)
    if(enemy_live[i]) {
      if(!(effect_on&&effect==3))
        enemy[i].y+=enemy_speed[i];
      if(enemy[i].y>SCREEN_H) enemy_live[i]=FALSE;
      if(!(effect_on&&effect==1)
       &&ship.x+(((BITMAP *)game_data[main_ship].dat)->w/2)>=enemy[i].x+int(sin(enemy_time+i*33)*10*enemy_speed[i])
       &&ship.x+(((BITMAP *)game_data[main_ship].dat)->w/2)<=enemy[i].x+int(sin(enemy_time+i*33)*10*enemy_speed[i])+(((BITMAP *)game_data[enemy_ship1].dat)->w)
       &&ship.y+(((BITMAP *)game_data[main_ship].dat)->h/2)>=enemy[i].y
       &&ship.y+(((BITMAP *)game_data[main_ship].dat)->h/2)<=enemy[i].y+(((BITMAP *)game_data[enemy_ship1].dat)->h)
      ) {
        lives--;
        enemy_live[i]=FALSE;
        ship.x=SCREEN_W/2;
        ship.y=SCREEN_H-(((BITMAP *)game_data[main_ship].dat)->h);
        effect_on=TRUE;
        effect=1;
        effect_time=100;
      }
       
    }
  if(lives<0) {
    game_over=TRUE;
    lives=0;
  }
  if(effect_on) {
    effect_time--;
    switch(effect) {
      case 1:            /* blink on and off; player can't be hurt */
        blink=!blink;
        break;
      case 2:            /* rapid fire                             */
        mb_speed=8;
        break;
      case 3:            /* Freeze enemy                           */
        break;
      case 4:            /* Gain life                              */
        lives++;
        effect_time=-1;
        break;
    }
    if(effect_time<0) {
      effect_on=FALSE;
      mb_speed=25;
      effect=0;
    }
  }
  for(i=0;i<max_mb;i++)
    if(mb_live[i]) {
      mb[i].y-=3;
    if(mb[i].y<0) mb_live[i]=FALSE;
    for(j=0;j<max_enemys;j++) {
      if(enemy_live[j]
         &&mb[i].x+(((BITMAP *)game_data[main_shot].dat)->w/2)>=enemy[j].x+int(sin(enemy_time+j*33)*10*enemy_speed[j])
         &&mb[i].x+(((BITMAP *)game_data[main_shot].dat)->w/2)<=enemy[j].x+int(sin(enemy_time+j*33)*10*enemy_speed[j])+(((BITMAP *)game_data[enemy_ship1].dat)->w)
         &&mb[i].y+(((BITMAP *)game_data[main_shot].dat)->h/2)>=enemy[j].y
         &&mb[i].y+(((BITMAP *)game_data[main_shot].dat)->h/2)<=enemy[j].y+(((BITMAP *)game_data[enemy_ship1].dat)->h)
        ) {
        enemy_live[j]=FALSE;
        mb_live[i]=FALSE;
        score+=5;
        level+=5;
      }
    }
  }
  if(!(effect_on&&effect==3))
    for(i=0;i<max_stars;i++) {
      stars[i].y+=(z_stars[i]>>2)+1;
      if(stars[i].y>SCREEN_H) {
        stars[i].x=rand()%SCREEN_W;
        stars[i].y=0;
        z_stars[i]=rand()%32;
      }
    }
     

  if(key[KEY_LEFT]) ship.x-=2;
  if(key[KEY_RIGHT]) ship.x+=2;
  if(key[KEY_UP]) ship.y-=2;
  if(key[KEY_DOWN]) ship.y+=2;
  if(ship.x<0) ship.x=0;
  if(ship.y<0) ship.y=0;
  if(ship.x>SCREEN_W-((BITMAP *)game_data[main_ship].dat)->w) ship.x=SCREEN_W-((BITMAP *)game_data[main_ship].dat)->w;
  if(ship.y>SCREEN_H-((BITMAP *)game_data[main_ship].dat)->h) ship.y=SCREEN_H-((BITMAP *)game_data[main_ship].dat)->h;

  if(game_over) {
    textout_centre(screen,font,"GAME OVER",SCREEN_W/2,SCREEN_H/2,makecol(255,255,255));
    textout_centre(screen,font,"Press ESC to continue",SCREEN_W/2,SCREEN_H/2+6,makecol(255,255,255));
    
    while(!key[KEY_ESC]);
    speed_var=0;
    
  }
  
  if(key[KEY_ESC]||game_over) {
    game_over=FALSE;
    do_game_init();       /* reset game */
    while(key[KEY_ESC]);
  }
}

void do_game_display() {
  BITMAP *buf;
  char a[2];
  a[1]=0;
  for(int i=0;i<max_stars;i++)
    putpixel(buffer,stars[i].x,stars[i].y,makecol(z_stars[i]<<3,z_stars[i]<<3,z_stars[i]<<3));
  if(go_menu) {
    buf=create_bitmap(150,50);
    clear(buf);
    textout_centre(buf,font,"Small arcade alien shooter",55,33,makecol(255,0,0));
    stretch_sprite(buffer,buf,0,0,450,150);
    destroy_bitmap(buf);
    
    textout_centre(buffer,font,"by Nathan Smith",SCREEN_W/2,SCREEN_H/2+12,makecol(255,0,0));
    textout_centre(buffer,font,"Press Space to start",SCREEN_W/2,SCREEN_H-12,makecol(255,255,255));
    textout_centre(buffer,font,"Press ESC to quit",SCREEN_W/2,SCREEN_H-6,makecol(255,255,255));
    
    return;
  }
  for(int i=0;i<max_enemys;i++)
    if(enemy_live[i])
      draw_sprite(buffer,(BITMAP *)game_data[enemy_ship1].dat,enemy[i].x+int(sin(enemy_time+i*33)*10*enemy_speed[i]),enemy[i].y);
  for(int i=0;i<max_mb;i++)
    if(mb_live[i])
      draw_sprite(buffer,(BITMAP *)game_data[main_shot].dat,mb[i].x,mb[i].y);

  if(effect_drop_live) {
    switch(effect_drop_type) {
      case 1:
        a[0]='I';
        break;
      case 2:
        a[0]='R';
        break;
      case 3:
        a[0]='T';
        break;
      case 4:
        a[0]='L';
        break;
      default:
        a[0]='?';     /* Game error */
        break;
    }
    textout(buffer,font,a,effect_drop.x,effect_drop.y,makecol(255,255,255));
    circle(buffer,effect_drop.x+text_length(font,"x")/2-1,effect_drop.y+text_height(font)/2-1,4,makecol(128,128,128));
  }

  if(effect_on&&effect==1) {
    if(blink) draw_sprite(buffer,(BITMAP *)game_data[main_ship].dat,ship.x,ship.y);
  }
  else
    draw_sprite(buffer,(BITMAP *)game_data[main_ship].dat,ship.x,ship.y);
  textprintf(buffer,font,0,0,makecol(255,255,255),"Score:%09d Level:%d Lives:%d",score,level_display,lives);

}
